Index: /quintagroup.canonicalpath/tags/0.6/MANIFEST.in
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/MANIFEST.in	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/MANIFEST.in	(revision 2164)
@@ -0,0 +1,3 @@
+recursive-include docs *
+recursive-include quintagroup *
+global-exclude *py[co]
Index: /quintagroup.canonicalpath/tags/0.6/README.txt
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/README.txt	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/README.txt	(revision 2164)
@@ -0,0 +1,43 @@
+Introduction
+============
+
+quintagroup.canonicalpath package brings canonical path calculation 
+functionality to Plone. The package allows to define path and/or link 
+to the object, which may differ from standard physical path or its URL
+in portal.
+
+It's used by such products as quintagroup.seoptimizer (for defining
+canonical link of the object) and quintagroup.plonegooglesitemaps (on
+google sitemaps generation).
+
+This package is intended for bringing *canonical_path* and/or
+*canonical_link* property to any traversable object. For that purpose
+it defines ICanonicalPath and ICanonicalLink interfaces, and registers
+basic adapters for ITraversable objects.
+
+This package also registers *canonical_path* and *canonical_link* indexes
+for possible usage in catalog (ZCatalog).
+
+Default adapters behaviour:
+
+- `canonical_path` returns path from portal root, i.e. for `/plone/front-page` canonical_path will be `/front-page`.
+
+- `canonical_link` returns absoulute url of the object.
+
+
+Supported Plone version
+-----------------------
+
+* 3.x
+
+
+Authors
+-------
+
+The product was developed by Quintagroup.com team:
+
+* Andriy Mylenkyi
+* Taras Melnychuk
+* Volodymyr Cherepanyak
+
+Copyright (c) "Quintagroup": http://quintagroup.com, 2004-2010
Index: /quintagroup.canonicalpath/tags/0.6/docs/HISTORY.txt
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/docs/HISTORY.txt	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/docs/HISTORY.txt	(revision 2164)
@@ -0,0 +1,28 @@
+Changelog
+=========
+
+0.6 (2010-04-19)
+----------------
+
+* added compatibility with plone 3.0-3.3 [fenix]
+* added compatibility for plone 4, removed unnecessary tests [fenix]
+* added delete property functionality for ICanonicalPath,
+  ICanonicalLink [mylan]
+* added ICanonicalLink interface/adapter/tests/indexer [mylan]
+
+
+0.4 (2010-02-11)
+----------------
+
+* Reregistered base adatapter for OFS.interface.ITraversable [mylan]
+* Rewrite indexer registration with help of plone.indexer [mylan]
+* Removed metadata registration in portal catalog [mylan]
+* Added tests [mylan]
+* Added README [mylan]
+
+
+0.1 (2009-03-13)
+----------------
+
+* Initial release
+
Index: /quintagroup.canonicalpath/tags/0.6/docs/INSTALL.txt
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/docs/INSTALL.txt	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/docs/INSTALL.txt	(revision 2164)
@@ -0,0 +1,51 @@
+Installation
+============
+
+Buildout
+--------
+
+To install quintagroup.canonicalpath to your buildout-based project:
+
+* Add ``quintagroup.canonicalpath`` to the list of eggs to install::
+
+    [buildout]
+    ...
+    eggs =
+        ...
+        quintagroup.canonicalpath
+       
+* Tell the plone.recipe.zope2instance recipe to install a ZCML slug::
+
+    [instance]
+    recipe = plone.recipe.zope2instance
+    ...
+    zcml =
+        quintagroup.canonicalpath
+      
+* Re-run buildout, e.g. with::
+
+    $ ./bin/buildout
+    
+* Restart the Zope server, e.g with the following command in the terminal::
+
+   $ ./bin/instance restart
+          
+
+Traditional Zope 2 instance
+---------------------------
+
+To install quintagroup.canonicalpath into the global Python environment (or a workingenv),
+using a traditional Zope 2 instance, you can do this:
+
+* Copy ``quintagroup`` folder to your instance's ``/lib/python`` directory.
+
+* Create a file called ``quintagroup.canonicalpath-configure.zcml`` in your instance's ``/etc/package-includes`` directory. The file
+should only contain this::
+
+    <include package="quintagroup.canonicalpath" />
+
+* Restart the Zope server, for example with the following command in the terminal::
+
+   $ ./bin/zopectl restart
+
+
Index: /quintagroup.canonicalpath/tags/0.6/docs/LICENSE.GPL
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/docs/LICENSE.GPL	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/docs/LICENSE.GPL	(revision 2164)
@@ -0,0 +1,225 @@
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
Index: /quintagroup.canonicalpath/tags/0.6/docs/LICENSE.txt
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/docs/LICENSE.txt	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/docs/LICENSE.txt	(revision 2164)
@@ -0,0 +1,16 @@
+  quintagroup.canonicalpath is copyright Quintagroup
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program; if not, write to the Free Software
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
+  MA 02111-1307 USA.
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup.canonicalpath-configure.zcml
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup.canonicalpath-configure.zcml	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup.canonicalpath-configure.zcml	(revision 2164)
@@ -0,0 +1,1 @@
+<include package="canonicalpath" />
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/__init__.py
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/__init__.py	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/__init__.py	(revision 2164)
@@ -0,0 +1,6 @@
+# See http://peak.telecommunity.com/DevCenter/setuptools#namespace-packages
+try:
+    __import__('pkg_resources').declare_namespace(__name__)
+except ImportError:
+    from pkgutil import extend_path
+    __path__ = extend_path(__path__, __name__)
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/README.txt
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/README.txt	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/README.txt	(revision 2164)
@@ -0,0 +1,21 @@
+quintagroup.canonicalpath package brings canonical path calculation 
+functionality to Plone. The package allows to define path and/or link 
+to the object, which may differ from standard physical path or its URL
+in portal.
+
+It's used by such products as quintagroup.seoptimizer (for defining
+canonical link of the object) and quintagroup.plonegooglesitemaps (on
+google sitemaps generation).
+
+This package is intended for bringing *canonical_path* and/or
+*canonical_link* property to any traversable object. For that purpose
+it defines ICanonicalPath and ICanonicalLink interfaces, and registers
+basic adapters for ITraversable objects.
+
+This package also registers *canonical_path* and *canonical_link* indexes
+for possible usage in catalog (ZCatalog).
+
+Default adapters behaviour:
+
+  - *canonical_path* returns path from portal root, i.e. for `/plone/front-page` *canonical_path* will be `/front-page`.
+  - *canonical_link* returns absoulute url of the object.
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/__init__.py
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/__init__.py	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/__init__.py	(revision 2164)
@@ -0,0 +1,1 @@
+#
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/adapters.py
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/adapters.py	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/adapters.py	(revision 2164)
@@ -0,0 +1,94 @@
+import re
+from zope.interface import implements
+from zope.component import adapts
+from zope.schema.interfaces import InvalidValue
+
+from OFS.interfaces import ITraversable
+from Products.CMFCore.utils import getToolByName
+
+from quintagroup.canonicalpath.interfaces import ICanonicalPath
+from quintagroup.canonicalpath.interfaces import ICanonicalLink
+
+PROPERTY_PATH = "canonical_path"
+PROPERTY_LINK = "canonical_link"
+
+_is_canonical = re.compile(
+    r"\S*$"               # non space and no new line(should be pickier)
+    ).match
+
+
+class DefaultCanonicalAdapter(object):
+    """Generic canonical adapter.
+    """
+    adapts(ITraversable)
+
+    prop = None
+
+    def __init__(self, context):
+        self.context = context
+        self.purl = getToolByName(self.context,'portal_url')
+
+    def _validate(self, value):
+        value.strip()
+        if not _is_canonical(value):
+            raise InvalidValue(value)
+        return value
+
+    def getDefault(self):
+        """Return default value for the self.prop"""
+        raise NotImplementedError()
+
+    def getProp(self):
+        """ First of all return value from the self.prop,
+        if self.prop not exist - return default value
+        """
+        if self.context.hasProperty(self.prop):
+            return self.context.getProperty(self.prop)
+
+        return self.getDefault()
+
+    def setProp(self, value):
+        """ First validate value, than add/updater self.prop
+        """
+        value = self._validate(value)
+
+        if self.context.hasProperty(self.prop):
+            self.context._updateProperty(self.prop, value)
+        else:
+            self.context._setProperty(self.prop, value, type="string")
+
+    def delProp(self):
+        """ Delete self.prop customization
+        """
+        if self.context.hasProperty(self.prop):
+            self.context.manage_delProperties(ids=[self.prop,])
+
+
+class DefaultCanonicalPathAdapter(DefaultCanonicalAdapter):
+    """Adapts base content to canonical path.
+    """
+    implements(ICanonicalPath)
+
+    prop = PROPERTY_PATH
+
+    def getDefault(self):
+        return '/'+'/'.join(self.purl.getRelativeContentPath(self.context))
+
+    canonical_path = property(DefaultCanonicalAdapter.getProp,
+                              DefaultCanonicalAdapter.setProp,
+                              DefaultCanonicalAdapter.delProp)
+
+
+class DefaultCanonicalLinkAdapter(DefaultCanonicalAdapter):
+    """Adapts base content to canonical link.
+    """
+    implements(ICanonicalLink)
+
+    prop = PROPERTY_LINK
+
+    def getDefault(self):
+        return self.context.absolute_url()
+
+    canonical_link = property(DefaultCanonicalAdapter.getProp,
+                              DefaultCanonicalAdapter.setProp,
+                              DefaultCanonicalAdapter.delProp)
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/catalog.py
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/catalog.py	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/catalog.py	(revision 2164)
@@ -0,0 +1,46 @@
+from zope.interface import Interface
+from zope.component import queryAdapter
+
+#for compatibility with older plone versions 
+try:
+    from plone.indexer.decorator import indexer 
+    IS_NEW = True
+except:
+    IS_NEW = False
+    class IDummyInterface:pass
+    class indexer:
+
+         def __init__(self, *interfaces):
+            self.interfaces = IDummyInterface,
+
+         def __call__(self, callable):
+             callable.__component_adapts__ = self.interfaces
+             callable.__implemented__ = Interface
+             return callable
+    
+from interfaces import ICanonicalPath
+from interfaces import ICanonicalLink
+
+@indexer(Interface)
+def canonical_path(obj, **kwargs):
+    """Return canonical_path property for the object.
+    """
+    adapter = queryAdapter(obj, interface=ICanonicalPath)
+    if adapter:
+        return adapter.canonical_path
+    return None
+
+@indexer(Interface)
+def canonical_link(obj, **kwargs):
+    """Return canonical_link property for the object.
+    """
+    adapter = queryAdapter(obj, interface=ICanonicalLink)
+    if adapter:
+        return adapter.canonical_link
+    return None
+
+#for compatibility with older plone versions 
+if not IS_NEW:
+    from Products.CMFPlone.CatalogTool import registerIndexableAttribute
+    map(registerIndexableAttribute, ('canonical_path', 'canonical_link'),
+                                    (canonical_path, canonical_link))
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/configure.zcml
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/configure.zcml	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/configure.zcml	(revision 2164)
@@ -0,0 +1,17 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:genericsetup="http://namespaces.zope.org/genericsetup">
+
+  <!-- Add general canonical_path adapter -->
+  <adapter factory=".adapters.DefaultCanonicalPathAdapter" />
+
+  <!-- Add general canonical_link adapter -->
+  <adapter factory=".adapters.DefaultCanonicalLinkAdapter" />
+
+  <!-- Register canonical_path adapter for catalog -->
+  <adapter name="canonical_path" factory=".catalog.canonical_path" />
+
+  <!-- Register canonical_link adapter for catalog -->
+  <adapter name="canonical_link" factory=".catalog.canonical_link" />
+
+</configure>
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/interfaces.py
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/interfaces.py	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/interfaces.py	(revision 2164)
@@ -0,0 +1,18 @@
+from zope.interface import Interface, Attribute
+
+class ICanonicalPath(Interface):
+    """canonical_path provider interface
+    """
+
+    canonical_path = Attribute("canonical_path",
+        "canonical_path - for the object. Adapter must implement "
+        "*setter* and *getter* for the attribute")
+
+class ICanonicalLink(Interface):
+    """canonical_link provider interface
+    """
+
+    canonical_link = Attribute("canonical_link",
+        "canonical_link - for the object. Adapter must implement "
+        "*setter* and *getter* for the attribute")
+
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/tests.py
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/tests.py	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/tests.py	(revision 2164)
@@ -0,0 +1,301 @@
+import unittest
+
+from zope.testing import doctestunit
+from zope.component import testing
+from zope.component import queryAdapter, queryMultiAdapter, getMultiAdapter
+from zope.schema.interfaces import InvalidValue
+
+#for compatibility with older plone versions 
+try:
+    from plone.indexer.interfaces import IIndexableObject
+    IS_NEW = True
+except:
+    from plone.app.content.interfaces import IIndexableObjectWrapper \
+        as _old_IIndexableObjectWrapper
+    IS_NEW = False
+
+
+from Testing import ZopeTestCase as ztc
+
+from Products.Five import zcml
+from Products.Five import fiveconfigure
+from Products.CMFCore.utils import getToolByName
+from Products.PloneTestCase import PloneTestCase as ptc
+from Products.PloneTestCase.layer import PloneSite
+
+from Products.Archetypes.tests.utils import makeContent
+
+from quintagroup.canonicalpath.interfaces import ICanonicalPath
+from quintagroup.canonicalpath.interfaces import ICanonicalLink
+from quintagroup.canonicalpath.adapters import PROPERTY_PATH
+from quintagroup.canonicalpath.adapters import PROPERTY_LINK
+
+class TestCase(ptc.PloneTestCase):
+    class layer(PloneSite):
+        @classmethod
+        def setUp(cls):
+            import quintagroup.canonicalpath
+            fiveconfigure.debug_mode = True
+            zcml.load_config('configure.zcml', quintagroup.canonicalpath)
+            fiveconfigure.debug_mode = False
+
+ptc.setupPloneSite()
+
+class TestIndexerRegistration(TestCase):
+
+    def afterSetUp(self):
+        self.loginAsPortalOwner()
+        self.catalog = getToolByName(self.portal, 'portal_catalog')
+        self.my_doc = makeContent(self.portal, portal_type='Document', id='my_doc')
+        self.logout()
+
+    def get_indexable_wrapper(self, obj):
+        if IS_NEW:
+            wrapper = None
+            if not IIndexableObject.providedBy(obj):
+                wrapper = queryMultiAdapter((obj, self.catalog), IIndexableObject)
+        else:
+            wf = getattr(self.portal, 'portal_workflow', None)
+            if wf is not None:
+                vars = wf.getCatalogVariablesFor(obj)
+            else:
+                vars = {}
+            wrapper = getMultiAdapter((obj, self.portal), _old_IIndexableObjectWrapper)
+            wrapper.update(vars)
+            
+        return wrapper and wrapper or obj
+
+    def testForAT(self):
+        wrapper = self.get_indexable_wrapper(self.my_doc)
+        self.assertFalse(wrapper is None, "No indexer registered for document object")
+
+    def testCanonicalPathForAT(self):
+        wrapper = self.get_indexable_wrapper(self.my_doc)
+        self.assertTrue(hasattr(wrapper, 'canonical_path'),
+            "'canonical_path' attribute not accessible with indexer wrapper for Document object")
+
+    def testCanonicalLinkForAT(self):
+        wrapper = self.get_indexable_wrapper(self.my_doc)
+        self.assertTrue(hasattr(wrapper, 'canonical_link'),
+            "'canonical_link' attribute not accessible with indexer wrapper for Document object")
+
+
+        
+class TestDefaultCanonicalPathAdapter(TestCase):
+
+
+    def afterSetUp(self):
+        self.loginAsPortalOwner()
+        self.purl = getToolByName(self.portal, 'portal_url')
+        self.my_doc = makeContent(self.portal, portal_type='Document', id='my_doc')
+        self.logout()
+
+        self.mydoc_cp = '/'+'/'.join(self.purl.getRelativeContentPath(self.my_doc))
+        self.portal_cp = '/'+'/'.join(self.purl.getRelativeContentPath(self.portal))
+
+    def testRegistration4Portal(self):
+        cpadapter = queryAdapter(self.portal, ICanonicalPath)
+        self.assertFalse(cpadapter is None,
+            "Can't get canonical path adapter for the plone site object")
+
+    def testRegistration4AT(self):
+        cpadapter = queryAdapter(self.my_doc, ICanonicalPath)
+        self.assertFalse(cpadapter is None,
+            "Can't get canonical path adapter for the Document object")
+        
+
+    def testGetDefault4Portal(self):
+        cpadapter = queryAdapter(self.portal, ICanonicalPath)
+        self.assertTrue(cpadapter.canonical_path == self.portal_cp,
+            "Canonical path adapter return '%s' for portal, must be: '%s'" % (
+            cpadapter.canonical_path, self.portal_cp) )
+
+
+    def testGetDefault4AT(self):
+        cpadapter = queryAdapter(self.my_doc, ICanonicalPath)
+        self.assertTrue(cpadapter.canonical_path == self.mydoc_cp,
+            "Canonical path adapter return '%s' for document, must be: '%s'" % (
+            cpadapter.canonical_path, self.mydoc_cp) )
+
+
+    def testSet4Portal(self):
+        cpadapter = queryAdapter(self.portal, ICanonicalPath)
+        newcp = self.portal_cp + '/new_portal_canonical'
+
+        cpadapter.canonical_path = newcp
+        prop = self.portal.getProperty(PROPERTY_PATH, None)
+        self.assertTrue(prop == newcp,
+            "Canonical path adapter setter NOT SET new '%s' value to '%s' " \
+            "propery for the portal" % (newcp, PROPERTY_PATH) )
+
+        self.assertTrue(cpadapter.canonical_path == newcp,
+            "Canonical path adapter GET '%s' canonical_path, for portal, " \
+            "must be: '%s'" % (cpadapter.canonical_path, newcp) )
+
+
+    def testSet4AT(self):
+        cpadapter = queryAdapter(self.my_doc, ICanonicalPath)
+        newcp = self.mydoc_cp + '/new_mydoc_canonical'
+
+        cpadapter.canonical_path = newcp
+        prop = self.my_doc.getProperty(PROPERTY_PATH, None)
+        self.assertTrue(prop == newcp,
+            "Canonical path adapter setter NOT SET new '%s' value to '%s' " \
+            "propery for the Document" % (newcp, PROPERTY_PATH) )
+
+        self.assertTrue(cpadapter.canonical_path == newcp,
+            "Canonical path adapter GET '%s' canonical_path, for Document, " \
+            "must be: '%s'" % (cpadapter.canonical_path, newcp) )
+
+
+    def testValidationWrong(self):
+        cpadapter = queryAdapter(self.my_doc, ICanonicalPath)
+        for wrong in ['new\nline','s p a c e','with\ttabs']:
+            try:
+                cpadapter.canonical_path = wrong
+            except InvalidValue:
+                continue
+            else:
+                raise self.failureException, "InvalidValue not raised when " \
+                      "'%s' wrong value try to set" % wrong
+        
+    def testValidationGood(self):
+        cpadapter = queryAdapter(self.my_doc, ICanonicalPath)
+        for good in ['./good','../good','/good', 'good']:
+            cpadapter.canonical_path = good
+
+
+    def testDeleteProperty(self):
+        hasprop = self.portal.hasProperty
+        cpadapter = queryAdapter(self.portal, ICanonicalPath)
+        cpadapter.canonical_path = '/new_portal_canonical'
+        assert hasprop(PROPERTY_PATH)
+
+        del cpadapter.canonical_path
+        self.assertFalse(hasprop(PROPERTY_PATH),
+            "Not deleted Canonical path customization property for the portal")
+
+
+    def testDelCustomization(self):
+        cpadapter = queryAdapter(self.portal, ICanonicalPath)
+        cpadapter.canonical_path = '/new_portal_canonical'
+        assert cpadapter.canonical_path == '/new_portal_canonical'
+
+        del cpadapter.canonical_path
+        self.assertTrue(cpadapter.canonical_path == self.portal_cp,
+            "After deleted Canonical path customization property not set to "
+            "default value for the portal")
+
+
+class TestDefaultCanonicalLinkAdapter(TestCase):
+
+    def afterSetUp(self):
+        self.loginAsPortalOwner()
+        self.purl = getToolByName(self.portal, 'portal_url')
+        self.my_doc = makeContent(self.portal, portal_type='Document', id='my_doc')
+        self.logout()
+
+        self.mydoc_cl = self.my_doc.absolute_url()
+
+    def testRegistration4Portal(self):
+        cladapter = queryAdapter(self.portal, ICanonicalLink)
+        self.assertFalse(cladapter is None,
+            "Can't get canonical link adapter for the plone site object")
+
+    def testRegistration4AT(self):
+        cladapter = queryAdapter(self.my_doc, ICanonicalLink)
+        self.assertFalse(cladapter is None,
+            "Can't get canonical link adapter for the Document object")
+        
+
+    def testGetDefault4Portal(self):
+        cladapter = queryAdapter(self.portal, ICanonicalLink)
+        self.assertTrue(cladapter.canonical_link == self.purl(),
+            "Canonical link adapter return '%s' for portal, must be: '%s'" % (
+            cladapter.canonical_link, self.purl()) )
+
+
+    def testGetDefault4AT(self):
+        cladapter = queryAdapter(self.my_doc, ICanonicalLink)
+        self.assertTrue(cladapter.canonical_link == self.mydoc_cl,
+            "Canonical link adapter return '%s' for document, must be: '%s'" % (
+            cladapter.canonical_link, self.mydoc_cl) )
+
+
+    def testSet4Portal(self):
+        cladapter = queryAdapter(self.portal, ICanonicalLink)
+        newcl = self.purl() + '/new_portal_canonical'
+
+        cladapter.canonical_link = newcl
+        prop = self.portal.getProperty(PROPERTY_LINK, None)
+        self.assertTrue(prop == newcl,
+            "Canonical link adapter setter NOT SET new '%s' value to '%s' " \
+            "propery for the portal" % (newcl, PROPERTY_LINK) )
+
+        self.assertTrue(cladapter.canonical_link == newcl,
+            "Canonical link adapter GET '%s' canonical_link, for portal, " \
+            "must be: '%s'" % (cladapter.canonical_link, newcl) )
+
+
+    def testSet4AT(self):
+        cladapter = queryAdapter(self.my_doc, ICanonicalLink)
+        newcl = self.mydoc_cl + '/new_mydoc_canonical'
+
+        cladapter.canonical_link = newcl
+        prop = self.my_doc.getProperty(PROPERTY_LINK, None)
+        self.assertTrue(prop == newcl,
+            "Canonical link adapter setter NOT SET new '%s' value to '%s' " \
+            "propery for the Document" % (newcl, PROPERTY_LINK) )
+
+        self.assertTrue(cladapter.canonical_link == newcl,
+            "Canonical link adapter GET '%s' canonical_link, for Document, " \
+            "must be: '%s'" % (cladapter.canonical_link, newcl) )
+
+    def testValidationWrong(self):
+        cladapter = queryAdapter(self.my_doc, ICanonicalLink)
+        for wrong in ['http://new\nline','s p a c e','with\ttabs']:
+            try:
+                cladapter.canonical_link = wrong
+            except InvalidValue:
+                continue
+            else:
+                raise self.failureException, "InvalidValue not raised when " \
+                    "'%s' wrong value try to set" % wrong
+        
+    def testValidationGood(self):
+        cladapter = queryAdapter(self.my_doc, ICanonicalLink)
+        for good in ['http://', './good','../good','/good', 'good']:
+            cladapter.canonical_link = good
+
+
+    def testDeleteProperty(self):
+        hasprop = self.portal.hasProperty
+        cladapter = queryAdapter(self.portal, ICanonicalLink)
+        cladapter.canonical_link = '/new_portal_canonical'
+        assert hasprop(PROPERTY_LINK)
+
+        del cladapter.canonical_link
+        self.assertFalse(hasprop(PROPERTY_LINK),
+            "Not deleted Canonical link customization property for the portal")
+
+
+    def test_DelCustomization(self):
+        cladapter = queryAdapter(self.portal, ICanonicalLink)
+        cladapter.canonical_link = '/new_portal_canonical'
+        assert cladapter.canonical_link == '/new_portal_canonical'
+
+        del cladapter.canonical_link
+        self.assertTrue(cladapter.canonical_link == self.purl(),
+            "After deleted Canonical link customization property not set to "
+            "default value for the portal")
+
+
+def test_suite():
+    return unittest.TestSuite([
+        unittest.makeSuite(TestIndexerRegistration),
+        unittest.makeSuite(TestDefaultCanonicalPathAdapter),
+        unittest.makeSuite(TestDefaultCanonicalLinkAdapter),
+        ])
+
+if __name__ == '__main__':
+    unittest.main(defaultTest='test_suite')
Index: /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/version.txt
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/version.txt	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/quintagroup/canonicalpath/version.txt	(revision 2164)
@@ -0,0 +1,1 @@
+0.2
Index: /quintagroup.canonicalpath/tags/0.6/setup.cfg
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/setup.cfg	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/setup.cfg	(revision 2164)
@@ -0,0 +1,3 @@
+[egg_info]
+tag_build = dev
+tag_svn_revision = true
Index: /quintagroup.canonicalpath/tags/0.6/setup.py
===================================================================
--- /quintagroup.canonicalpath/tags/0.6/setup.py	(revision 2164)
+++ /quintagroup.canonicalpath/tags/0.6/setup.py	(revision 2164)
@@ -0,0 +1,38 @@
+from setuptools import setup, find_packages
+import os
+
+version = '0.6'
+
+tests_require=['zope.testing']
+setup(name='quintagroup.canonicalpath',
+      version=version,
+      description="Brings canonical path calculation functionality",
+      long_description=open("README.txt").read() + "\n" +
+                       open(os.path.join("docs", "HISTORY.txt")).read(),
+      # Get more strings from http://www.python.org/pypi?%3Aaction=list_classifiers
+      classifiers=[
+        "Programming Language :: Python",
+        "Topic :: Software Development :: Libraries :: Python Modules",
+        ],
+      keywords='canonical path plone quintagroup',
+      author='Quintagroup',
+      author_email='support@quintagroup.com',
+      url='http://svn.quintagroup.com/products/quintagroup.canonicalpath',
+      license='GPL',
+      packages=find_packages(exclude=['ez_setup']),
+      namespace_packages=['quintagroup'],
+      include_package_data=True,
+      zip_safe=False,
+      install_requires=[
+          'setuptools',
+      ],
+      tests_require=tests_require,
+      extras_require=dict(tests=tests_require),
+      test_suite = 'quintagroup.canonicalpath.tests.test_suite',
+      entry_points="""
+      # -*- Entry points: -*-
+      [z3c.autoinclude.plugin]
+      target = plone
+      """,
+      )
+ 
